/**************************************************************
** 	Mini Stm32f103 
**	Eshop:
**  http://kavirelectronic.ir/eshop 
**	Support Team:
**	http://IranMicro.ir  
**  03527730313
***************************************************************/ 

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x.h"
#include "hardware.h"
#include "ili932x.h"
#include "font.h"


unsigned int  HDP=479;
unsigned int  HT=531;
unsigned int  HPS=43;
unsigned int  LPS=8;
unsigned char HPW=10;

unsigned int  VDP=271;



unsigned int  VT=288;
unsigned int  VPS=12;
unsigned int  FPS=4;
unsigned char   VPW=10;

uint32_t POINT_COLOR = BLUE,BACK_COLOR = WHITE;  /* ֱõɫ͵ɫ	*/

void LCD_WriteReg(uint16_t LCD_Reg,uint16_t LCD_Dat)
{
	Write_Cmd(LCD_Reg);
	Write_Dat(LCD_Dat);
}
void Write_Cmd(uint16_t LCD_Reg)
{
	LCD_CS = 0;
	LCD_RS = 0;
	GPIOC->ODR = (GPIOC->ODR&0xff00)|(LCD_Reg&0x00ff);
	GPIOB->ODR = (GPIOB->ODR&0x00ff)|(LCD_Reg&0xff00); 
	LCD_WR = 0;
	LCD_WR = 1;	
	LCD_CS = 1;
}
void Write_Dat(uint16_t LCD_Dat)
{
	LCD_CS = 0;
	LCD_RS = 1;
	GPIOC->ODR = (GPIOC->ODR&0xff00)|(LCD_Dat&0x00ff);
	GPIOB->ODR = (GPIOB->ODR&0x00ff)|(LCD_Dat&0xff00);
	LCD_WR = 0;
	LCD_WR = 1;	
	LCD_CS = 1;
}
uint16_t LCD_ReadReg(uint16_t LCD_Reg)
{
	uint16_t temp;
	Write_Cmd(LCD_Reg);  //дҪļĴ  

	GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x44444444; //˿ڸ8λó
	GPIOC->CRL = (GPIOC->CRL & 0x00000000) | 0x44444444; //˿ڵ8λó  
	LCD_CS = 0;
	LCD_RS = 1;
	LCD_RD = 0;
	temp = ((GPIOB->IDR&0xff00)|(GPIOC->IDR&0x00ff)); //ȡ(Ĵʱ,Ҫ2) 	
	LCD_RD = 1;
	LCD_CS = 1; 
	GPIOB->CRH = (GPIOB->CRH & 0x00000000) | 0x33333333; //ͷŶ˿ڸ8λΪ
	GPIOC->CRL = (GPIOC->CRL & 0x00000000) | 0x33333333; //ͷŶ˿ڵ8λΪ
	return temp;   
}

uint16_t LCD_ReadDat()
{
	uint16_t temp;

	GPIOE->CRH = (GPIOE->CRH & 0x00000000) | 0x44444444;  //˿ڸ8λó
	GPIOE->CRL = (GPIOE->CRL & 0x00000000) | 0x44444444;  //˿ڵ8λó
	LCD_CS = 0;
	LCD_RS = 1;
	LCD_RD = 0;
	temp = ((GPIOB->IDR&0xff00)|(GPIOC->IDR&0x00ff));	//ȡ(Ĵʱ,Ҫ2)
	LCD_RD = 1;
	LCD_CS = 1;
	GPIOE->CRH = (GPIOE->CRH & 0x00000000) | 0x33333333;  //ͷŶ˿ڸ8λΪ
	GPIOE->CRL = (GPIOE->CRL & 0x00000000) | 0x33333333;  //ͷŶ˿ڵ8λΪ

	return temp;   
}

void LCD_Configuration()
{
	GPIO_InitTypeDef GPIO_InitStructure;
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB | RCC_APB2Periph_GPIOC,ENABLE);

	/* IO ӵGPIOB *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 
								| GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   // ʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  // IOΪ50MHZ
  	GPIO_Init(GPIOB, &GPIO_InitStructure);
	
	/* ÿIO ӵPD12.PD13.PD14.PD15 *********************/	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_2 | GPIO_Pin_3 
								| GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7 
								| GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11;
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;   // ʽ
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  // IOΪ50MHZ
  	GPIO_Init(GPIOC, &GPIO_InitStructure);
}

void LCD_Init(void)
{
	static uint16_t DeviceCode;
	LCD_Configuration();
	LCD_WriteReg(0x0000,0x0001);
	LCD_Delay(5); // LCD_Delay 50 ms 
	DeviceCode = LCD_ReadReg(0x0000);   
	printf(" ID=0x%x\n",DeviceCode); 
	///////////////////////////////////
	LCD_Delay(5); // delay 50 ms 
	Write_Cmd(0x00E2);	//PLL multiplier, set PLL clock to 120M
	Write_Dat(0x0023);	    //N=0x36 for 6.5M, 0x23 for 10M crystal
	Write_Dat(0x0002);
	Write_Dat(0x0004);
	
	Write_Cmd(0x00E0);  // PLL enable
	Write_Dat(0x0001);
	LCD_Delay(1);
	Write_Cmd(0x00E0);
	Write_Dat(0x0003);
	LCD_Delay(5);
	Write_Cmd(0x0001);  // software reset
	LCD_Delay(5);
	Write_Cmd(0x00E6);	//PLL setting for PCLK, depends on resolution
	Write_Dat(0x0001);
	Write_Dat(0x0033);
	Write_Dat(0x0032);

	Write_Cmd(0x30);
	Write_Dat(0);
	Write_Dat(1);
	Write_Dat(HDP>>8);
	Write_Dat(HDP&0xff);

	Write_Cmd(0x00B0);	//LCD SPECIFICATION
	Write_Dat(0x0020);
	Write_Dat(0x0000);
	Write_Dat((HDP>>8)&0X00FF);  //Set HDP
	Write_Dat(HDP&0X00FF);
    Write_Dat((VDP>>8)&0X00FF);  //Set VDP
	Write_Dat(VDP&0X00FF);
    Write_Dat(0x0000);

	Write_Cmd(0x00B4);	//HSYNC
	Write_Dat((HT>>8)&0X00FF);  //Set HT
	Write_Dat(HT&0X00FF);
	Write_Dat((HPS>>8)&0X00FF);  //Set HPS
	Write_Dat(HPS&0X00FF);
	Write_Dat(HPW);			   //Set HPW
	Write_Dat((LPS>>8)&0X00FF);  //Set HPS
	Write_Dat(LPS&0X00FF);
	Write_Dat(0x0000);

	Write_Cmd(0x00B6);	//VSYNC
	Write_Dat((VT>>8)&0X00FF);   //Set VT
	Write_Dat(VT&0X00FF);
	Write_Dat((VPS>>8)&0X00FF);  //Set VPS
	Write_Dat(VPS&0X00FF);
	Write_Dat(VPW);			   //Set VPW
	Write_Dat((FPS>>8)&0X00FF);  //Set FPS
	Write_Dat(FPS&0X00FF);

	Write_Cmd(0x00F0); //pixel data interface
	Write_Dat(0x0003); /*16λ565ʽ*/

    Write_Cmd(0x0021);	//ͼɫתģʽ

	Write_Cmd(0x00BC);//Ҫ
	Write_Dat(0x0080);//Աȶ
	Write_Dat(0x0080);//
	Write_Dat(0x0080);//Ͷֵ  //
	Write_Dat(0x0001);//
	Write_Cmd(0x0029); //display on

	LCD_Clear(BLACK);

}

void WR_DATA_Prepare(void)
{
	Write_Cmd(0x002c);
}

void LCD_DrawPoint(uint16_t x, uint16_t y, uint16_t color)
{
	LCD_SetCursor(x,y);      //ùλ 
	LCD_WriteRAM_Prepare();         //ʼдGRAM
	Write_Dat(color); 	
}

void LCD_WriteRAM_Prepare()
{
	Write_Cmd(0x002c);	
}

void LCD_SetCursor(uint8_t Xpos,uint16_t Ypos)
{
	Write_Cmd(0x002A);	
	Write_Dat(Xpos>>8);	    
	Write_Dat(Xpos&0x00ff);
	Write_Dat(479>>8);	    
	Write_Dat(479&0x00ff);
    Write_Cmd(0x002b);	
	Write_Dat(Ypos>>8);	    
	Write_Dat(Ypos&0x00ff);
	Write_Dat(271>>8);	    
	Write_Dat(271&0x00ff);	
} 

//
//Color:Ҫɫ
void LCD_Clear(u32 color)
{
    unsigned int l=480,w;

	Write_Cmd(0x002a);	
	Write_Dat(0);	    
	Write_Dat(0);
	Write_Dat(HDP>>8);	    
	Write_Dat(HDP&0x00ff);

    Write_Cmd(0x002b);	
	Write_Dat(0);	    
	Write_Dat(0);
	Write_Dat(VDP>>8);	    
	Write_Dat(VDP&0x00ff);

	Write_Cmd(0x002c);
	while(l--)
	{
	    for(w=0;w<272;w++)
		{
			Write_Dat(color);		
		}
	} 
}  

void LCD_Delay (uint32_t nCount)
{
	__IO uint16_t i;	 	
	for (i=0;i<nCount*100;i++);
}

void LCD_WindowMax (unsigned int xsta,unsigned int ysta,unsigned int xend,unsigned int yend) 
{
	Write_Cmd(0X002A);
	Write_Dat(xsta>>8);
	Write_Dat(xsta&0X00FF);
	Write_Dat(xend>>8);
	Write_Dat(xend&0X00FF);
		
	Write_Cmd(0X002B);	
	Write_Dat(ysta>>8);	
	Write_Dat(ysta&0X00FF);
	Write_Dat(yend>>8);	
	Write_Dat(yend&0X00FF);			
}

void LCD_Fill(uint8_t xsta, uint16_t ysta, uint8_t xend, uint16_t yend, uint16_t colour)
{                    
    u32 n;

	LCD_WindowMax (xsta, ysta, xend, yend); 
	LCD_WriteRAM_Prepare();         /*ʼдGRAM*/	 	   	   
	n=(u32)(yend-ysta+1)*(xend-xsta+1);    
	while(n--){Write_Dat(colour);} /*ʾɫ*/	 
}

/**
	*ƣvoid LCD_DrawLine(uint16_t xsta, uint16_t ysta, uint16_t xend, uint16_t yend)
**/ 
void LCD_DrawLine(uint16_t xsta, uint16_t ysta, uint16_t xend, uint16_t yend, uint16_t color)
{
    u16 x, y, t;	 
	if((xsta==xend)&&(ysta==yend))
		LCD_DrawPoint(xsta, ysta, color);
	else 
		if(abs(yend-ysta)>abs(xend-xsta))/*бʴ1 */ 
		{
			if(ysta>yend) 
			{
				t=ysta;
				ysta=yend;
				yend=t; 
				t=xsta;
				xsta=xend;
				xend=t; 
			}
			for(y=ysta;y<yend;y++)            /*yΪ׼*/ 
			{
				x=(u32)(y-ysta)*(xend-xsta)/(yend-ysta)+xsta;
				LCD_DrawPoint(x, y, color);  
			}
		}
		else     /*бСڵ1 */
		{
			if(xsta>xend)
			{
				t=ysta;
				ysta=yend;
				yend=t;
				t=xsta;
				xsta=xend;
				xend=t;
			}   
			for(x=xsta;x<=xend;x++)  /*xΪ׼*/ 
			{
				y =(u32)(x-xsta)*(yend-ysta)/(xend-xsta)+ysta;
				LCD_DrawPoint(x, y, color); 
			}
		} 
}

/**
	*ƣvoid Draw_Circle(uint16_t x0, uint16_t y0, uint8_t r)
**/
void Draw_Circle(uint16_t x0, uint16_t y0, uint8_t r, uint16_t color)
{
	int a,b;
	int di;
	a=0;b=r;	  
	di=3-(r<<1);             /*ж¸λõı־*/
	while(a<=b)
	{
		LCD_DrawPoint(x0-b, y0-a, color);             //3           
		LCD_DrawPoint(x0+b, y0-a, color);             //0           
		LCD_DrawPoint(x0-a, y0+b, color);             //1       
		LCD_DrawPoint(x0-b, y0-a, color);             //7           
		LCD_DrawPoint(x0-a, y0-b, color);             //2             
		LCD_DrawPoint(x0+b, y0+a, color);             //4               
		LCD_DrawPoint(x0+a, y0-b, color);             //5
		LCD_DrawPoint(x0+a, y0+b, color);             //6 
		LCD_DrawPoint(x0-b, y0+a, color);             
		a++;

		if(di<0)di +=4*a+6;	  
		else
		{
			di+=10+4*(a-b);   
			b--;
		} 
		LCD_DrawPoint(x0+a, y0+b, color);
	}
} 

/**
	*ƣvoid LCD_DrawRectangle(uint16_t xsta, uint16_t ysta, uint16_t xend, uint16_t yend)

**/
void LCD_DrawRectangle(uint16_t xsta, uint16_t ysta, uint16_t xend, uint16_t yend, uint16_t color)
{
	LCD_DrawLine(xsta, ysta, xend, ysta, color);
	LCD_DrawLine(xsta, ysta, xsta, yend, color);
	LCD_DrawLine(xsta, yend, xend, yend, color);
	LCD_DrawLine(xend, ysta, xend, yend, color);
}

/**
	*ƣvoid LCD_ShowChar(u8 x, u16 y, u8 num, u8 size, u16 PenColor, u16 BackColor)
**/
void LCD_ShowChar(u8 x, u16 y, u8 num, u8 size, u16 PenColor, u16 BackColor)
{       
#define MAX_CHAR_POSX 232
#define MAX_CHAR_POSY 304 
    u8 temp;
    u8 pos,t;
    if(x>MAX_CHAR_POSX||y>MAX_CHAR_POSY)return;		    
	num=num-' ';                         /*õƫƺֵ */
	for(pos=0;pos<size;pos++)
	{
		temp=asc2_1608[num][pos];		 /*1608	*/
		for(t=0;t<size/2;t++)
	    {                 
	        if(temp&0x01)			   /*ӵλʼ*/
			{
				LCD_DrawPoint(x+t, y+pos, PenColor);  /*ɫ һ*/
			}
			else 
				LCD_DrawPoint(x+t, y+pos, BackColor);	   /*ɫ һ*/     
	        temp>>=1; 
	    }
	}			
} 

//m^n
u32 mypow(u8 m,u8 n)
{
	u32 result=1;	 
	while(n--)result*=m;    
	return result;
}			 

void LCD_ShowNum(u8 x,u8 y,u32 num,u8 len, u16 PenColor, u16 BackColor)
{    
	u8 size = 16; /*  ʹĬϵ16*8  */     	
	u8 t,temp;
	u8 enshow=0;						   
	for(t=0;t<len;t++)
	{
		temp=(num/mypow(10,len-t-1))%10;
		if(enshow==0&&t<(len-1))
		{
			if(temp==0)
			{
				LCD_ShowChar(x+(size/2)*t,y,' ',size, PenColor, BackColor);
				continue;
			}else enshow=1; 
		 	 
		}
	 	LCD_ShowChar(x+(size/2)*t,y,temp+'0',size, PenColor, BackColor); 
	}
} 
  


/**
	ƣvoid LCD_ShowCharString(uint16_t x, uint16_t y, const uint8_t *p, uint16_t PenColor, uint16_t BackColor)
**/

void LCD_ShowCharString(uint16_t x, uint16_t y, const uint8_t *p, uint16_t PenColor, uint16_t BackColor)
{   
	uint8_t size = 16;     /*---ַСĬ16*8---*/
	 
    if(x>MAX_CHAR_POSX){x=0;y+=size;}			         /*XСλ*/
    if(y>MAX_CHAR_POSY){y=x=0;LCD_Clear(WHITE);}	 /*YСλصԭ㣬*/
    LCD_ShowChar(x, y, *p, size, PenColor, BackColor);			   /*0ʾǵӷʽ*/
}

/**
	*: u16 findHzIndex(u8 *hz)
	*hz
	*ܣִ洢ڴַ
	*ע
**/
u16 findHzIndex(u8 *hz)                            /* Զ庺ֿڲҪʾ */
                                                      /* ĺֵλ */
{
	u16 i=0;
	FNT_GB16 *ptGb16 = (FNT_GB16 *)GBHZ_16;		  /*ptGb16ָGBHZ_16*/
	while(ptGb16[i].Index[0] > 0x80)
	{
	    if ((*hz == ptGb16[i].Index[0]) && (*(hz+1) == ptGb16[i].Index[1])) /*λʾַ*/
		{
	        return i;
	    }
	    i++;
	    if(i > (sizeof((FNT_GB16 *)GBHZ_16) / sizeof(FNT_GB16) - 1))  /* ±Լ */
	    {
		    break;
	    }
	}
	return 0;
}

/**
	*ƣvoid WriteOneHz(uint16_t x0, uint16_t y0, uint8_t *pucMsk, uint16_t PenColor, uint16_t BackColor)
	*x0,y0     ʼ
		   *pucMsk   ָ
		   PenColor	 ַɫ
		   BackColor ɫ
	*ܣ
	*ע˺ܵΪַʾ											  
**/					
void WriteOneHz(u16 x0, u16 y0, u8 *pucMsk, u16 PenColor, u16 BackColor)
{
    u16 i,j;
    u16 mod[16];                                      /* ǰģ 16*16 */
    u16 *pusMsk;                                      /* ǰַֿ  */
    u16 y;
    pusMsk = (u16 *)pucMsk;
    for(i=0; i<16; i++)                                    /* 浱ǰֵʽģ       */
    {
        mod[i] = *pusMsk;                                /* ȡõǰģֶ   */
        mod[i] = ((mod[i] & 0xff00) >> 8) | ((mod[i] & 0x00ff) << 8);/* ģߵֽ*/
		pusMsk = pusMsk+1;
    }
    y = y0;
    for(i=0; i<16; i++)                                    /* 16   */
    {                                              
        for(j=0; j<16; j++)                                /* 16   */
        {
		    if((mod[i] << j) & 0x8000)       /* ʾi 16 */
            {
				LCD_DrawPoint(x0+j, y0+i, PenColor); 
            } 
			else 
			{
				LCD_DrawPoint(x0+j, y0+i, BackColor);
			}
        }
        y++;
    }
}

/**
	*ƣvoid LCD_ShowHzString(u16 x0, u16 y0, u8 *pcStr, u16 PenColor, u16 BackColor)
	*x0y0    ʼ
		   pcStr     ָ
		   PenColor  ɫ
		   BackColor 屳
	*ܣʾַ
	*עܵ	       
**/
void LCD_ShowHzString(u16 x0, u16 y0, u8 *pcStr, u16 PenColor, u16 BackColor)
{
#define MAX_HZ_POSX 224
#define MAX_HZ_POSY 304 
	u16 usIndex;
	u8 size = 16; 
	FNT_GB16 *ptGb16 = 0;    
    ptGb16 = (FNT_GB16 *)GBHZ_16; 

	if(x0>MAX_HZ_POSX){x0=0;y0+=size;}			         /*XСλ*/
    if(y0>MAX_HZ_POSY){y0=x0=0;LCD_Clear(WHITE);}	   /*YСλصԭ㣬*/

	usIndex = findHzIndex(pcStr);
	WriteOneHz(x0, y0, (u8 *)&(ptGb16[usIndex].Msk[0]),  PenColor, BackColor); /* ʾַ */
}

/**
	*ƣvoid LCD_ShowString(u16 x0, u16 y0, u8 *pcstr, u16 PenColor, u16 BackColor)
	*x0 y0     ʼ
		   pcstr     ַָ
		   PenColor  ɫ
		   BackColor 屳ɫ
	*ܣַͺʾʵַʾ
	*ע	
**/
void LCD_ShowString(u16 x0, u16 y0, u8 *pcStr, u16 PenColor, u16 BackColor)
{
	while(*pcStr!='\0')
	{
	 	if(*pcStr>0x80) /*ʾ*/
		{
			LCD_ShowHzString(x0, y0, pcStr, PenColor, BackColor);
			pcStr += 2;
			x0 += 16;	
		}
		else           /*ʾַ*/
		{
			LCD_ShowCharString(x0, y0, pcStr, PenColor, BackColor);	
			pcStr +=1;
			x0+= 8;
		}
	
	}	

}

/****************************************************************************
*     ƣu16 ili9320_BGRtoRGB(u16 Color)
*     ܣRRRRRGGGGGGBBBBB Ϊ BBBBBGGGGGGRRRRR ʽ
* ڲColor      BRG ɫֵ
* ڲRGB ɫֵ
* ˵    ڲ
* ÷
****************************************************************************/
u16 LCD_RGBtoBGR(u16 Color)
{						   
  u16  r, g, b, bgr;

  b = (Color>>0)  & 0x1f;	/* ȡB    */
  g = (Color>>5)  & 0x3f;	/* мλ */
  r = (Color>>11) & 0x1f;	/* ȡR    */
  
  bgr =  (b<<11) + (g<<5) + (r<<0);

  return( bgr );
}

/****************************************************************************
*     ƣvoid LCD_DrawPicture(u16 StartX,u16 StartY,u16 EndX,u16 EndY,u16 *pic)
*     ܣָ귶ΧʾһͼƬ
* ڲStartX     ʼ
*           StartY     ʼ
*           EndX       н
*           EndY       н
            pic        ͼƬͷָ
* ڲ
* ˵    ͼƬȡģʽΪˮƽɨ裬16λɫģʽ
* ÷LCD_DrawPicture(0,0,100,100,(u16*)demo);
****************************************************************************/
void LCD_DrawPicture(u16 StartX,u16 StartY,u16 Xend,u16 Yend,u8 *pic)
{
	static	u16 i=0,j=0;
	u16 *bitmap = (u16 *)pic;
	for(j=0; j<Yend-StartY; j++)
	{
		for(i=0; i<Xend-StartX; i++) 
		LCD_DrawPoint(StartX+i, StartY+j, *bitmap++); 	
	}
}